找回密码
 立即注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

查看: 1035|回复: 0

[分享] Add prefix and suffix to the text or mtext

[复制链接]

已领礼包: 859个

财富等级: 财运亨通

发表于 2014-6-7 03:06:16 | 显示全部楼层 |阅读模式

马上注册,结交更多好友,享用更多功能,让你轻松玩转社区。

您需要 登录 才可以下载或查看,没有账号?立即注册

×
        #region "Add prefix and suffix to the text or mtext multiply"
        [CommandMethod("PSUF")]
        public static void UpdateMultipleTexts()
        {

            Database db = HostApplicationServices.WorkingDatabase;

            Editor ed = Autodesk.AutoCAD.ApplicationServices.Application.DocumentManager.MdiActiveDocument.Editor;

            Transaction tr = db.TransactionManager.StartTransaction();

            string pref = GetstringDflt(ed, "Enter a Prefix: ", "A-");

            string suff = GetstringDflt(ed, "Enter a Suffix: ", "-B");

            using (tr)
            {

                try
                {
                    Entity ent;

                    PromptEntityResult per;

                    ObjectId id;

                    do
                    {
                        PromptEntityOptions peo = new PromptEntityOptions("\nSelect Text >>");
                        peo.SetRejectMessage("\nMust be selected a Text or Mtext only!");

                        peo.AddAllowedClass(typeof(DBText),false);

                        peo.AddAllowedClass(typeof(MText),false);

                        per = ed.GetEntity(peo);

                        if (per.Status != PromptStatus.OK)
                        {
                            break;
                        }
                        id = per.ObjectId;

                        ent = id.GetObject(OpenMode.ForRead) as Entity;

                        ed.WriteMessage("\nObject Selected:\t{0}", ent.GetRXClass().DxfName);

                        if ((!(ent is DBText)) && (!(ent is MText)))
                        {
                            ed.WriteMessage("\nNot a Text or MText");
                            continue;
                        }
                        DBText txt= ent as DBText;
                        if (txt!= null)
                        {
                            txt.UpgradeOpen();
                            string text = txt.TextString;
                            txt.TextString = pref + text+ suff;
                            txt.DowngradeOpen();
                        }

                        MText mtxt = ent as MText;
                        if (mtxt != null)
                        {
                            mtxt.UpgradeOpen();
                            string text = mtxt.Contents;
                            mtxt.Contents = pref + text + suff;
                            mtxt.DowngradeOpen();
                        }
                     
                        db.TransactionManager.QueueForGraphicsFlush();
                    }
                    while (per.Status == PromptStatus.OK);
                    tr.Commit();
                }

                catch (Autodesk.AutoCAD.Runtime.Exception ex)
                {

                    ed.WriteMessage("\n" + ex.StackTrace + "\n" + ex.Message);
                }

            }
        }
        #region "Helpers"
        public static string GetstringDflt(Editor ed, string msg, string dflt)
        {
            string answer = string.Empty;

            PromptStringOptions pso = new PromptStringOptions("\n" + msg);

            if (dflt != string.Empty)
            {
                pso.DefaultValue = dflt;
            }
            pso.AllowSpaces = true;

            PromptResult pr = ed.GetString(pso);

            if (pr.Status == PromptStatus.OK)
            {
                answer = pr.StringResult;
            }
            return answer;
        }
        #endregion

        #endregion
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

QQ|申请友链|Archiver|手机版|小黑屋|辽公网安备|晓东CAD家园 ( 辽ICP备15016793号 )

GMT+8, 2024-12-18 23:56 , Processed in 0.375903 second(s), 27 queries , Gzip On.

Powered by Discuz! X3.5

© 2001-2024 Discuz! Team.

快速回复 返回顶部 返回列表